/* scanner test (to show that DMA is working) | GT 1996. 12. 26
   FILE: demo/scantest */

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <linux/scanner.h>

void main() {			     /* print data received from the scanner */
  int				 n, fd, r, sl, m, ht, mag = 1;
  struct m105_modeinfo_struct	 mi;
  unsigned char			 buf[207];
  
  if((fd = open("/dev/scanner", O_RDONLY)) < 0) {
    perror("open");
    exit(1);
  }
  if((ioctl(fd, HSIOCGMOD, &mi)) < 0) {
    perror("ioctl");
    close(fd);
    exit(2);
  }
  printf("Scanner set to %d dpi (%d bytes per scanline)\n", mi.dpi, mi.bpl);
  while(1) {
    for(sl = 0; sl < ht;) {
      if((r = read(fd, &buf, mi.bpl)) < 0) {
	perror("read");
	close(fd);
	exit(1);
      } else if(r > 0) {
	for(n = 0; n < mi.bpl; n++) fprintf(stdout, "%c", buf[n]);
	fprintf(stdout, "\n");
      }
    }
  }
} /* end of main(scantest) */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
